from oacleanup.utils.billing_db import get_connection_to_billing_db
from poaupdater import uSysDB


def find_duplicates(items):
    seen = set()
    duplicates = set()
    for item in items:
        if item not in seen:
            seen.add(item)
        else:
            duplicates.add(item)

    return duplicates


def find_invalide_values(items):
    result = []
    for item in items:
        try:
            v = int(item)
            if v <= 0:
                result.append(item)
        except ValueError:
            result.append(item)

    return result


def find_absent_values(items, sql, use_billing=False):
    con = get_connection_to_billing_db() if use_billing else uSysDB.connect()
    cur = con.cursor()
    cur.execute(sql, (tuple(items),))
    return set(items).difference([x for [x] in cur.fetchall()])
