# (C)2018 Ingram Micro Inc. all Rights Reserve
from poaupdater import openapi, pbaapi, apsapi, uCrypt, uSysDB


def is_billing_installed():
    open_api = openapi.OpenAPI()
    token = open_api.pem.APS.getAccountToken(account_id=1)['aps_token']
    aapi = apsapi.API(url='https://localhost:6308')
    resp = aapi.GET(
        path='/aps/2/resources?implementing(http://www.parallels.com/products/automation/billing)',
        headers={"APS-Token": token},
    )

    return bool(resp)

def _init_pbaapi():
    pbaapi.initFromEnv()
    if not pbaapi._settings.username:
        pbaapi._settings.username = 'admin'

        con = uSysDB.connect()
        cur = con.cursor()
        cur.execute("SELECT value FROM bmbridge_settings WHERE name = 'bm.common.password'")
        rows = cur.fetchall()
        decrypted_password = rows[0][0]
        pbaapi._settings.password = uCrypt.decryptData(decrypted_password)

def get_billing_api():
    _init_pbaapi()
    return pbaapi.PBAAPI()

def get_raw_billing_api():
    _init_pbaapi()
    return pbaapi.PBAAPIRaw()
