from poaupdater import uHCL, uBilling
import psycopg2


def _perform_hcl_to_node(node, command, complain_empty_stdout=True):
    request = uHCL.Request(node, user='root', group='root')
    request.command(command, stdout='stdout', stderr='stderr')
    output = request.perform()

    if output['stderr'] != "":
        raise Exception("Command '%s' on node %i executed with an error. \n"
                        "STDOUT: '%s'\n"
                        "STDERR: '%s'" % (command, node, output['stdout'], output['stderr']))

    if output['stdout'] == "" and complain_empty_stdout:
        raise Exception("Command '%s' on node %i returned an empty string" % (command, node))

    return output['stdout'].strip()


def get_connection_to_billing_db(db_name = 'pba'):
    bss_host_id = uBilling.PBAConf().get_host_id()
    db_user = _perform_hcl_to_node(bss_host_id,
                                   "cat /usr/local/bm/etc/ssm.conf.d/.global.conf /usr/local/bm/etc/ssm.conf.d/global.conf | "
                                   "egrep 'DB_USER\s?=' | tail -1").split("=")[-1].strip()
    db_passwd = _perform_hcl_to_node(bss_host_id,
                                     "cat /usr/local/bm/etc/ssm.conf.d/global.conf | "
                                     "egrep 'DB_PASSWD\s?='").split("=")[-1].strip()
    db_host = _perform_hcl_to_node(bss_host_id,
                                   "cat /usr/local/bm/etc/ssm.conf.d/global.conf | "
                                   "egrep 'DB_HOST\s?='").split("=")[-1].strip()
    return psycopg2.connect("dbname='%s' user='%s' host='%s' password='%s'" % (db_name, db_user, db_host, db_passwd))


def is_billing_db_table_exists(pba_db_connection, db_table_name):
    with pba_db_connection.cursor() as cur:
        cur.execute("select count(1) from pg_tables where tablename = '%s'" % db_table_name)
        return cur.fetchone()[0]
