# (C)2018 Ingram Micro Inc. all Rights Reserve
from poaupdater import openapi

import logging

from oacleanup.utils.errors import CleanUpException
from oacleanup.settings import OA_NAME

logger = logging.getLogger()


def unregister_modules(short_module_name):
    try:
        api = openapi.OpenAPI()
        api.pem.packaging.unregisterModule(short_name=short_module_name)
    except Exception, e:
        raise CleanUpException("Unable to deregister the %s module from %s: %s." % (short_module_name, OA_NAME, e))


def is_module_installed(module):
    try:
        api = openapi.OpenAPI()
        installed_modules = api.pem.packaging.listInstalledModules()
        return module in installed_modules
    except Exception, e:
        raise CleanUpException('Unable to retrieve a list of modules installed on %s: %s.' % (OA_NAME, e))


def deregister_role(role_name):
    logger.info('Removing the %s role from %s...' % (role_name, OA_NAME))
    try:
        api = openapi.OpenAPI()
        api.pem.deregisterRole(name=role_name)
    except Exception, e:
        raise CleanUpException('Unable to remove the role %s: %s.' % (role_name, e))

    logger.info('The %s role was removed from %s.' % (role_name, OA_NAME))
