# (C)2018 Ingram Micro Inc. all Rights Reserve
from oacleanup.utils import hosts, packages

from poaupdater import uPackaging, uSysDB


MN_NODE_ID = 1

def get_backup_nodes_by_subs(subs):
    if not subs:
        return []

    con = uSysDB.connect()
    cur = con.cursor()

    query = ('SELECT DISTINCT host_id FROM backups_groups'
             ' WHERE subscription_id IN %s')
    cur.execute(query, (tuple(subs),))

    return [host_id for host_id, in cur.fetchall()]


def remove_packages_from_service_nodes(indicator_services, module_services):
    host_ids = hosts.get_host_ids_by_services(indicator_services)
    if not host_ids:
        return 0

    packages.remove_packages_on_hosts(host_ids, module_services)
    return len(host_ids)
