# (C)2018 Ingram Micro Inc. all Rights Reserve
from poaupdater import uSysDB


def get_service_template_ids_by_service_names(service_names, is_active=False):
    if not service_names:
        return []

    # templates having at least one resource linked to service by attribute
    q = ('SELECT DISTINCT st_id'
         ' FROM service_templates'
         ' JOIN st_resources USING (st_id)'
         ' JOIN resource_types USING (rt_id)'
         ' JOIN resource_classes USING (class_id)'
         ' JOIN services USING (sc_id)'
         ' JOIN rt_attributes USING (rt_id)'
         ' JOIN host_attributes USING (host_id)'
         ' WHERE rt_attributes.attribute = host_attributes.host_attribute'
         ' AND services.name IN %s')
    if is_active:
        q += " AND service_templates.for_sale = 'y'"

    con = uSysDB.connect()
    cur = con.cursor()

    cur.execute(q, (tuple(service_names),))
    tmpls_with_attrs = [st_id for [st_id] in cur.fetchall()]

    # templates having resources w/o attributes
    q = ('SELECT DISTINCT st_id'
         ' FROM service_templates'
         ' JOIN st_resources USING (st_id)'
         ' JOIN resource_types USING (rt_id)'
         ' JOIN resource_classes USING (class_id)'
         ' JOIN services USING (sc_id)'
         ' LEFT JOIN rt_attributes USING (rt_id)'
         ' WHERE services.name IN %s'
         ' GROUP BY st_id'
         ' HAVING COUNT(rt_attributes.rt_id) = 0')
    if is_active:
        q += " AND service_templates.for_sale = 'y'"

    cur.execute(q, (tuple(service_names),))
    tmpls_no_attrs = [st_id for [st_id] in cur.fetchall()]

    return list(set(tmpls_with_attrs + tmpls_no_attrs))

